//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add Business Module" recipe.
//
// This class contains placeholder methods for the common module initialization 
// tasks, such as adding services, or user-interface element
//
// For more information see: 
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-280-Automation%20Add%20Business%20Module.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using TaskViewer.Infrastructure.Interface;
using Microsoft.Practices.CompositeUI;
using Microsoft.Practices.CompositeUI.Commands;
using TaskViewer.AdministrationModule.Constants;
using System.Collections.Generic;

namespace TaskViewer.AdministrationModule
{
    public class ModuleController : WorkItemController
    {
        public override void Run()
        {
            AddServices();
            ExtendMenu();
            ExtendToolStrip();
            AddViews();
        }

        private void AddServices()
        {
            //TODO: add services provided by the Module. See: Add or AddNew method in 
            //		WorkItem.Services collection or see ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.practices.2005Nov.cab/CAB/html/03-020-Adding%20Services.htm
        }

        private void ExtendMenu()
        {
             ToolStripMenuItem administrationMenuItem = new ToolStripMenuItem(Properties.Resources.AdministrationMenuItem);
            WorkItem.UIExtensionSites[UIExtensionSiteNames.MainMenu].Add(administrationMenuItem);

            AddMenuItem(administrationMenuItem, Properties.Resources.NewUserItem, CommandNames.NewUser, Keys.U | Keys.Alt);

            //TODO: add menu items here, normally by calling the "Add" method on
            //		on the WorkItem.UIExtensionSites collection. For an example 
            //		See: ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.practices.2005Nov.cab/CAB/html/03-100-Showing%20UIElements.htm
        }

        private void AddMenuItem(ToolStripMenuItem parent, string text, string command, Keys shortcutKeys)
        {
            ToolStripMenuItem item = new ToolStripMenuItem(text);
            item.ShortcutKeys = shortcutKeys;
            parent.DropDownItems.Add(item);

            WorkItem.Commands[command].AddInvoker(item, "Click");
        }

        private void ExtendToolStrip()
        {
            ToolStripButton administrationButton = new ToolStripButton(Properties.Resources.Users.ToBitmap());
            WorkItem.UIExtensionSites[UIExtensionSiteNames.OutlookNavigation].Add(administrationButton);

            WorkItem.Commands[CommandNames.AdministrationSelected].AddInvoker(administrationButton, "Click");
            //TODO: add new items to the ToolStrip in the Shell. See the UIExtensionSites collection in the WorkItem. 
            //		See: ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.practices.2005Nov.cab/CAB/html/03-100-Showing%20UIElements.htm
        }

        private void AddViews()
        {
            //TODO: create the Module views, add them to the WorkItem and show them in 
            //		a Workspace. See: ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-300-Adding%20a%20View.htm
            UserList userList = WorkItem.Items.AddNew<UserList>(ViewNames.UserList);
            WorkItem.Workspaces[WorkspaceNames.SummaryWorkspace].Show(userList);

            UserDetails userDetails = WorkItem.Items.AddNew<UserDetails>(ViewNames.UserDetails);
            WorkItem.Workspaces[WorkspaceNames.DetailWorkspace].Show(userDetails);

            NavigationArea navigation = WorkItem.Items.AddNew<NavigationArea>(ViewNames.NavigationArea);
            WorkItem.Workspaces[WorkspaceNames.NavigationWorkspace].Show(navigation);
        }

        [CommandHandler(CommandNames.NewUser)]
        public void OnNewUser(object sender, EventArgs args)
        {
            IUserDetails view = WorkItem.SmartParts.AddNew<UserDetails>();
            WorkItem.Workspaces[WorkspaceNames.ModalWindows].Show(view);
        }

        [CommandHandler(CommandNames.AdministrationSelected)]
        public void OnAdministrationSelected(object sender, EventArgs args)
        {
            UserList userList = WorkItem.Items.Get<UserList>(ViewNames.UserList);
            WorkItem.Workspaces[WorkspaceNames.SummaryWorkspace].Show(userList);

            UserDetails userDetails = WorkItem.Items.Get<UserDetails>(ViewNames.UserDetails);
            WorkItem.Workspaces[WorkspaceNames.DetailWorkspace].Show(userDetails);

            NavigationArea navigation = WorkItem.Items.Get<NavigationArea>(ViewNames.NavigationArea);
            WorkItem.Workspaces[WorkspaceNames.NavigationWorkspace].Show(navigation);
        }
        //TODO: Add CommandHandlers and/or Event Subscriptions
        //		See: ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.practices.2005Nov.cab/CAB/html/03-110-Registering%20Commands.htm
        //		See: ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.practices.2005Nov.cab/CAB/html/03-080-Publishing%20and%20Subscribing%20to%20Events.htm
    }
}
