//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add View" recipe.
//
// This class is the concrete implementation of a View in the Model-View-Presenter 
// pattern. Communication between the Presenter and this class is acheived through 
// an interface to facilitate separation and testability.
// Note that the Presenter generated by the same recipe, will automatically be created
// by CAB through [CreateNew] and bidirectional references will be added.
//
// For more information see:
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-030-Model%20View%20Presenter%20%20MVP%20.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using Microsoft.Practices.CompositeUI.SmartParts;
using Microsoft.Practices.ObjectBuilder;
using TaskViewer.Infrastructure.Interface;
using TaskViewer.Infrastructure.Interface.BusinessEntities;

namespace TaskViewer.AdministrationModule
{
    [SmartPart]
    public partial class UserList : UserControl, IUserList
    {
        public UserList()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Sets the presenter. The dependency injection system will automatically
        /// create a new presenter for you.
        /// </summary>
        [CreateNew]
        public UserListPresenter Presenter
        {
            set
            {
                _presenter = value;
                _presenter.View = this;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            _presenter.OnViewReady();
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        delegate void ShowUserDelegate(User[] users);
        public void ShowUsers(User[] users)
        {
            if (InvokeRequired)
            {
                this.Invoke(new ShowUserDelegate(InnerShowUser), new object[] { users });
            }
            else
            {
                InnerShowUser(users);
            }
        }

        public void InnerShowUser(User[] users)
        {
            _userBindingSource.DataSource = users;
        }

        private void _userdataGridView_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            User user = (User)_userBindingSource.Current;


            _presenter.UserSelected(user);
        }
    }
}

