
using System.Security.Authentication;
using System.Security.Principal;
using System.Threading;
using Microsoft.Practices.CompositeUI;
using Microsoft.Practices.CompositeUI.Services;
using Microsoft.Practices.ObjectBuilder;
using TaskViewer.Infrastructure.Interface.Services;
using TaskViewer.Infrastructure.Interface.BusinessEntities;
using TaskViewer.Infrastructure.Library.Properties;

namespace TaskViewer.Infrastructure.Library.Services
{
    public class SimpleWinFormAuthenticationService : IAuthenticationService, IConfigurable
    {
        public string _userName;
        public string _role;

        
        public SimpleWinFormAuthenticationService(User user)
        {
            
        }

        public SimpleWinFormAuthenticationService()
        {

        }


        public void Authenticate()
        {
            
            if(!string.IsNullOrEmpty(_userName) && ! string.IsNullOrEmpty(_role))
            {
                GenericIdentity identity = new GenericIdentity(_userName);
                GenericPrincipal principal ;
                principal = new GenericPrincipal(identity, new string[] { _role });
                
                Thread.CurrentPrincipal = principal;
            }
            else
            {
                throw new AuthenticationException(Resources.NoUserProvidedForAuthentication);
            }
        }

        #region IConfigurable Members

        public void Configure(System.Collections.Specialized.NameValueCollection settings)
        {
            if (settings.Count == 2)
            {
                _userName = settings[0];
                _role = settings[1];
            }
        }

        #endregion
    }
}
