//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by this guidance package as part of the solution template
//
// The SolutionProfileV1Parser class provides the implementation for v1 of the Profile Catalog
// 
// For more information see: 
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-210-Creating%20a%20Smart%20Client%20Solution.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System.Collections.Generic;
using TaskViewer.Infrastructure.Library.SolutionProfileV1;
using Microsoft.Practices.CompositeUI.Configuration;
using TaskViewer.Infrastructure.Library.Services;

namespace TaskViewer.Infrastructure.Library.Services
{
    public class SolutionProfileV1Parser : ISolutionProfileParser
    {
        public const string Namespace = "http://schemas.microsoft.com/pag/cab-profile";

        public IModuleInfo[] Parse(string xml)
        {
            SolutionProfileElement solution = XmlValidationHelper.DeserializeXml<SolutionProfileV1.SolutionProfileElement>(xml,
                "SolutionProfileV1.xsd", Namespace);

            List<ModuleInfo> mis = new List<ModuleInfo>();

            if (solution.Modules != null)
            {
                foreach (ModuleInfoElement moduleInfo in solution.Modules)
                {
                    ModuleInfo mi = new ModuleInfo(moduleInfo.AssemblyFile);
                    SetModuleRoles(moduleInfo, mi);
                    mis.Add(mi);
                }
            }

            return mis.ToArray();
        }

        private static void SetModuleRoles(ModuleInfoElement moduleInfo, ModuleInfo mi)
        {
            if (moduleInfo.Roles != null && moduleInfo.Roles.Length > 0)
                foreach (RoleElement role in moduleInfo.Roles)
                    mi.AddRoles(role.Allow);
        }
    }
}

