using System;
using System.Collections.Generic;
using System.Text;
using TaskViewer.Infrastructure.Interface.Services;
using System.Security.Principal;
using System.Threading;

namespace TaskViewer.Infrastructure.Module.Services
{
    public class GenericPrincipalImpersonationContext : IImpersonationContext
    {
        private IPrincipal _oldPrincipal;

        public object State
        {
            get
            {
                return _oldPrincipal;
            }
            set
            {
                _oldPrincipal = value as IPrincipal;
            }
        }

        public void Undo()
        {
            Thread.CurrentPrincipal = _oldPrincipal;
        }

        #region IDisposable Members

        public void Dispose()
        {
            Dispose(true);
        }

        #endregion

        protected virtual void Dispose(bool disposing)
        {
            if (disposing)
            {
                Undo();
            }
        }
    }
}
