using System;
using System.Collections.Generic;
using System.Text;

using TaskViewer.Infrastructure.Interface.BusinessEntities;
using TaskViewer.TaskManagement.ServiceAgent.BusinessEntities;

using TaskViewer.Infrastructure.Library.EntityTranslators;
using TaskManagement.ServiceProxies.TaskViewer.DataService;

namespace TaskViewer.TaskManagement.ServiceAgent.EntityTranslator
{
    public class TaskTranslator: EntityMapperTranslator<Task, TasksInfo.TasksRow>
    {
        protected override TasksInfo.TasksRow BusinessToService(TaskViewer.Infrastructure.Interface.Services.IEntityTranslatorService service, Task value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        protected override Task ServiceToBusiness(TaskViewer.Infrastructure.Interface.Services.IEntityTranslatorService service, TasksInfo.TasksRow value)
        {
            Task task = new Task();
            task.AssignedToID = value.AssignedTo;
            task.AssignedTo = value.AssignedToText;
            task.DateCreated = value.DateCreated;
            task.DateModified = value.DateModified;
            task.DueDate = value.DateDue;
            task.IsDeleted = value.IsDeleted;
            task.ModifiedBy = value.ModifiedByText;
            task.ModifiedByID = value.ModifiedBy;
            task.Priority = value.PriorityText;
            task.PriorityID = value.PriorityID;
            task.Progress = value.Progress;
            task.ProjectId = value.ProjectID;
            task.Status = value.StatusText;
            task.StatusID = value.StatusID;
            task.TaskDescription = value.TaskDescription;
            task.TaskId = value.TaskID;
            task.TaskSummary = value.TaskSummary;
            return task;
        }
    }
}
