using System;
using System.Collections.Generic;
using System.Text;

using TaskViewer.TaskManagement.ServiceAgent.BusinessEntities;

using TaskViewer.Infrastructure.Interface.BusinessEntities;

namespace TaskViewer.TaskManagement.ServiceAgent
{

    public delegate void GetProjectsCallback(Project[] projects);
    public delegate void GetTasksCallback(Task[] tasks);

    public interface ITaskManagementServiceAgent
    {
        void GetProjects(GetProjectsCallback callback);
        void GetTasks(Int32 projectID, GetTasksCallback callback);
        Priority[] GetPriorities();
        Status[] GetStatuses();
        User[] GetUsers();
        void AddProject();
        void AddTask();
        void UpdateTask(Task task);
        void GoOnline();
        void GoOffline();
       

        
    }
}
