//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add View" recipe.
//
// A presenter calls methods of a view to update the information that the view displays. 
// The view exposes its methods through an interface definition, and the presenter contains
// a reference to the view interface. This allows you to test the presenter with different 
// implementations of a view (for example, a mock view).
//
// For more information see:
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-030-Model%20View%20Presenter%20%20MVP%20.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;

using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeUI;

using TaskViewer.Infrastructure.Interface;
using TaskViewer.TaskManagement.ServiceAgent;

namespace TaskViewer.TaskManagement
{
    public class CollisionViewPresenter : Presenter<ICollisionView>
    {

        private ITaskManagementServiceAgent _taskServiceAgent;

        [InjectionConstructor]
        public CollisionViewPresenter
            (
            [ServiceDependency] ITaskManagementServiceAgent taskServiceAgent
            )
        {
            _taskServiceAgent = taskServiceAgent;
        }
        /// <summary>
        /// This method is a placeholder that will be called by the view when it's been loaded <see cref="System.Winforms.Control.OnLoad"/>
        /// </summary>
        public override void OnViewReady()
        {
            base.OnViewReady();
        }

        /// <summary>
        /// Close the view
        /// </summary>
        public void OnCloseView()
        {
            base.CloseView();
        }
    }
}

