using System;
using System.Windows.Forms;

using TaskViewer.TaskManagement.ServiceAgent.BusinessEntities;

namespace TaskViewer.TaskManagement.Mappers
{
    public static class TaskMapper
    {
        public static DataGridViewRow ToGridViewRow(Task task)
        {
            return new TaskDataGridViewRow(task);
        }

        public static Task FromGridViewRow( DataGridViewRow dataGridViewRow)
        {
            TaskDataGridViewRow taskDataGridViewRow = 
                dataGridViewRow as TaskDataGridViewRow;
            return taskDataGridViewRow.Task;

        } 
    }

    private class TaskDataGridViewRow: DataGridViewRow
    {
        private Task _task;

public Task Task
{
  get { return _task; }
  set { _task = value; }
}
    }
    private class AttachmentListViewItem : ListViewItem
    {
      private Attachment _attachment;

      public AttachmentListViewItem(Attachment attachment)
      {
        Name = attachment.DisplayName;
        Text = attachment.DisplayName;
        SubItems.Add(AttachmentStatusToDisplayText(attachment));
        _attachment = attachment;
      }

      private static string AttachmentStatusToDisplayText(Attachment attachment)
      {
        switch (attachment.Status)
        {
          case Attachment.AttachmentStatus.AvailableModified:
            return "Modified";

          case Attachment.AttachmentStatus.AvailableNotModified:
            return "Available";

          case Attachment.AttachmentStatus.Downloading:
            return "Downloading...";

          case Attachment.AttachmentStatus.NotAvailable:
            return "To be downloaded";

          case Attachment.AttachmentStatus.ToBeUploaded:
            return "To be uploaded";

          case Attachment.AttachmentStatus.Uploaded:
            return "Uploaded";

          case Attachment.AttachmentStatus.Uploading:
            return "Uploading";
        }

        return attachment.Status.ToString();
      }

      public Attachment Attachment
      {
        get { return _attachment; }
      }
    }
  }
}

}
