//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add View" recipe.
//
// This class is the concrete implementation of a View in the Model-View-Presenter 
// pattern. Communication between the Presenter and this class is acheived through 
// an interface to facilitate separation and testability.
// Note that the Presenter generated by the same recipe, will automatically be created
// by CAB through [CreateNew] and bidirectional references will be added.
//
// For more information see:
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-030-Model%20View%20Presenter%20%20MVP%20.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using Microsoft.Practices.CompositeUI.SmartParts;
using Microsoft.Practices.ObjectBuilder;
using TaskViewer.Infrastructure.Interface;
using TaskViewer.Infrastructure.Interface.Services;
using Microsoft.Practices.CompositeUI;
using TaskViewer.Infrastructure.Library.UI;

namespace TaskViewer.TaskManagement
{
    [SmartPart]
    public partial class NewProjectView : UserControl, INewProjectView, ISmartPartInfoProvider
    {
        public NewProjectView()
        {
            InitializeComponent();
        }

        IMessageBoxService _messageBoxService;

        [ServiceDependency]
        public IMessageBoxService MessageBoxService
        {
            set { _messageBoxService = value; }
        }

        /// <summary>
        /// Sets the presenter. The dependency injection system will automatically
        /// create a new presenter for you.
        /// </summary>
        [CreateNew]
        public NewProjectViewPresenter Presenter
        {
            set
            {
                _presenter = value;
                _presenter.View = this;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            _presenter.OnViewReady();
        }

        private void NewProjectView_Load(object sender, EventArgs e)
        {

        }

        private void _cancelButton_Click(object sender, EventArgs e)
        {
            _presenter.OnCloseView();
        }

        private void _okButton_Click(object sender, EventArgs e)
        {
            _presenter.InsertProject(_projectName.Text, _description.Text);
        }

        #region ISmartPartInfoProvider Members

        public ISmartPartInfo GetSmartPartInfo(Type smartPartInfoType)
        {
            ISmartPartInfo spi;


            if (smartPartInfoType.IsAssignableFrom(typeof(WindowSmartPartInfo)))
            {
                WindowSmartPartInfo wspi = new WindowSmartPartInfo();
                wspi.Modal = true;
                wspi.MinimizeBox = false;
                wspi.MaximizeBox = false;
                wspi.ControlBox = true;

                wspi.Keys[WindowWorkspaceSetting.FormBorderStyle] = FormBorderStyle.FixedDialog;
                wspi.Keys[WindowWorkspaceSetting.AcceptButton] = _okButton;
                wspi.Keys[WindowWorkspaceSetting.CancelButton] = _cancelButton;
                spi = wspi;
            }
            else
            {
                spi = Activator.CreateInstance(smartPartInfoType) as ISmartPartInfo;
            }

            spi.Description = Properties.Resources.NewProjectDescription;
            spi.Title = Properties.Resources.NewProjectTitle; 

            return spi;
        }

        #endregion
    }
}

