//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add View" recipe.
//
// This class is the concrete implementation of a View in the Model-View-Presenter 
// pattern. Communication between the Presenter and this class is acheived through 
// an interface to facilitate separation and testability.
// Note that the Presenter generated by the same recipe, will automatically be created
// by CAB through [CreateNew] and bidirectional references will be added.
//
// For more information see:
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-030-Model%20View%20Presenter%20%20MVP%20.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using Microsoft.Practices.CompositeUI.SmartParts;
using Microsoft.Practices.ObjectBuilder;
using TaskViewer.Infrastructure.Interface;
using TaskViewer.Infrastructure.Interface.Services;
using Microsoft.Practices.CompositeUI;
using TaskViewer.Infrastructure.Library.UI;
using System.Collections.Generic;
using TaskViewer.TaskManagement.ServiceAgent.BusinessEntities;

namespace TaskViewer.TaskManagement
{
    [SmartPart]
    public partial class OfflineSelectionView : UserControl, IOfflineSelectionView, ISmartPartInfoProvider
    {
        private const string _allProjects = "(All)";

        public OfflineSelectionView()
        {
            InitializeComponent();
        }

        IMessageBoxService _messageBoxService;

        [ServiceDependency]
        public IMessageBoxService MessageBoxService
        {
            set { _messageBoxService = value; }
        }

        /// <summary>
        /// Sets the presenter. The dependency injection system will automatically
        /// create a new presenter for you.
        /// </summary>
        [CreateNew]
        public OfflineSelectionViewPresenter Presenter
        {
            set
            {
                _presenter = value;
                _presenter.View = this;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            _presenter.OnViewReady();
        }

       
        private void _cancelButton_Click(object sender, EventArgs e)
        {
            _presenter.OnCloseView();
        }

        private void _okButton_Click(object sender, EventArgs e)
        {
            if (_projectsListBox.CheckedItems.Count > 0)
            {
                
                int i;
                List<Project> selectedProjects = new List<Project>();
                // "(All)" is not a real project, so start with 1 and skip item 0
                for (i = 1; i < _projectsListBox.Items.Count; i++)
                {
                    
                    if ((_projectsListBox.GetItemCheckState(i) == CheckState.Checked) || (_projectsListBox.GetItemCheckState(0) == CheckState.Checked))
                    {
                      
                       selectedProjects.Add((Project)_projectsListBox.Items[i]);
                       
                        
                    }                   
                }
                _presenter.SaveProjects(selectedProjects);
            }

           
        }

        #region IOfflineSelectionView Members

        public void ShowProjects(Project[] projects)
        {
            _projectsListBox.Items.Clear();
            _projectsListBox.DisplayMember = "Name";
            _projectsListBox.Items.Add(new Project(-1, _allProjects, String.Empty, DateTime.Now));
            foreach (Project project in projects)
            {
              
                _projectsListBox.Items.Add(project);
            }
        }

        #endregion

        #region ISmartPartInfoProvider Members

        public ISmartPartInfo GetSmartPartInfo(Type smartPartInfoType)
        {
            ISmartPartInfo spi;


            if (smartPartInfoType.IsAssignableFrom(typeof(WindowSmartPartInfo)))
            {
                WindowSmartPartInfo wspi = new WindowSmartPartInfo();
                wspi.Modal = true;
                wspi.MinimizeBox = false;
                wspi.MaximizeBox = false;
                wspi.ControlBox = true;

                wspi.Keys[WindowWorkspaceSetting.FormBorderStyle] = FormBorderStyle.FixedDialog;
                wspi.Keys[WindowWorkspaceSetting.AcceptButton] = _okButton;
                wspi.Keys[WindowWorkspaceSetting.CancelButton] = _cancelButton;
                spi = wspi;
            }
            else
            {
                spi = Activator.CreateInstance(smartPartInfoType) as ISmartPartInfo;
            }

            spi.Description = Properties.Resources.WorkOfflineDescription;
            spi.Title = Properties.Resources.WorkOfflineTitle;

            return spi;
        }

        #endregion

        private void _projectsListBox_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            // if all is checked
            if (e.Index == 0 && e.NewValue == CheckState.Checked)
            {
                // uncheck the others (which will cause this to run again)
                foreach (int item in _projectsListBox.CheckedIndices)
                {
                    if (item != 0)
                        _projectsListBox.SetItemCheckState(item, CheckState.Unchecked);
                }
                // now enable the ok button
                _okButton.Enabled = true;
            }
            else if (e.Index != 0 && e.NewValue == CheckState.Checked)
            {
                // something not "(All)" is checked true
                // set "(All)" to unchecked
                _projectsListBox.SetItemCheckState(0, CheckState.Unchecked);
                _okButton.Enabled = true;
            }
            else
            {
                // any item is checked false
               
                if (_projectsListBox.CheckedItems.Count == 1)
                    _okButton.Enabled = false;
            }
        }

    }
}

