//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add View" recipe.
//
// This class is the concrete implementation of a View in the Model-View-Presenter 
// pattern. Communication between the Presenter and this class is acheived through 
// an interface to facilitate separation and testability.
// Note that the Presenter generated by the same recipe, will automatically be created
// by CAB through [CreateNew] and bidirectional references will be added.
//
// For more information see:
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-030-Model%20View%20Presenter%20%20MVP%20.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;

using Microsoft.Practices.CompositeUI.SmartParts;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeUI.Utility;

using TaskViewer.TaskManagement.ServiceAgent.BusinessEntities;
using TaskViewer.Infrastructure.Interface;

namespace TaskViewer.TaskManagement
{
    [SmartPart]
    public partial class ProjectNavigation : UserControl, IProjectNavigation
    {
        private ImageList _imageList = new ImageList();

        public ProjectNavigation()
        {
            InitializeComponent();
            _imageList.Images.Add(Properties.Resources.project);
            treeViewProjects.ImageList = _imageList;
        }

        /// <summary>
        /// Sets the presenter. The dependency injection system will automatically
        /// create a new presenter for you.
        /// </summary>
        [CreateNew]
        public ProjectNavigationPresenter Presenter
        {
            set
            {
                _presenter = value;
                _presenter.View = this;
            }
            get
            {
                return _presenter;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            
            _presenter.OnViewReady();
        }

        #region IProjectNavigation Members
        delegate void ShowTaskDelegate(Project[] projects);

        public void ShowProjects(Project[] projects)
        {
            Guard.ArgumentNotNull(projects, "projects");
            if (InvokeRequired)
            {
                BeginInvoke(new ShowTaskDelegate(InnerShowProjects), new Object[] { projects});
            }
            else
            {
                InnerShowProjects(projects);
            }
            
        }

        void InnerShowProjects(Project[] projects)
        {
            foreach (Project project in projects)
            {
                TreeNode node = new TreeNode(project.Name,0,0);
                node.Tag = project;
                treeViewProjects.Nodes.Add(node);
            }
        }

        #endregion

        private void treeViewProjects_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            TreeNode node = ((TreeView)sender).SelectedNode;
            Project selectedProject = node.Tag as Project;
            if (selectedProject != null)
            {
                _presenter.ProjectSelected(selectedProject);
            }
            else
            {
                throw new NullReferenceException(this._presenter.ToString());
            }
        }
    }
}

