//----------------------------------------------------------------------------------------
// patterns & practices - Smart Client Software Factory - Guidance Package
//
// This file was generated by the "Add View" recipe.
//
// This class is the concrete implementation of a View in the Model-View-Presenter 
// pattern. Communication between the Presenter and this class is acheived through 
// an interface to facilitate separation and testability.
// Note that the Presenter generated by the same recipe, will automatically be created
// by CAB through [CreateNew] and bidirectional references will be added.
//
// For more information see:
// ms-help://MS.VSCC.v80/MS.VSIPCC.v80/ms.scsf.2006jun/SCSF/html/03-030-Model%20View%20Presenter%20%20MVP%20.htm
//
// Latest version of this Guidance Package: http://go.microsoft.com/fwlink/?LinkId=62182
//----------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

using Microsoft.Practices.CompositeUI.SmartParts;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeUI.Utility;

using TaskViewer.TaskManagement.ServiceAgent.BusinessEntities;
using TaskViewer.Infrastructure.Interface;

namespace TaskViewer.TaskManagement
{
    [SmartPart]
    public partial class TasksReview : UserControl, ITasksReview
    {
        public TasksReview()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Sets the presenter. The dependency injection system will automatically
        /// create a new presenter for you.
        /// </summary>
        [CreateNew]
        public TasksReviewPresenter Presenter
        {
            set
            {
                _presenter = value;
                _presenter.View = this;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            _presenter.OnViewReady();
        }

        private void TasksReview_Load(object sender, EventArgs e)
        {

        }

        #region ITasksReview Members
        delegate  void ShowTaskDelegate(Task[] tasks);
        public void ShowTasks(Task[] tasks)
        {
            if (InvokeRequired)
            {
                this.Invoke(new ShowTaskDelegate(InnerShowTask), new object[]{tasks});
            }
            else
            {
                InnerShowTask(tasks);
            }
        }

        public void InnerShowTask(Task[] tasks)
        {
            _taskBindingSource.DataSource = tasks;
        }

        #endregion

        #region EventHandlers

        private void dataGridViewTasks_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
        {
            foreach (DataGridViewRow row in dataGridViewTasks.Rows)
            {
                
                DataGridViewImageCell imageCell = (DataGridViewImageCell)dataGridViewTasks[_priorityText.Index, row.Index];
                DataGridViewTextBoxCell priorityCell = (DataGridViewTextBoxCell)dataGridViewTasks[_Priority.Index, row.Index];
                switch (priorityCell.Value.ToString())
                {
                    case "Major":
                        imageCell.Value = Properties.Resources.Major;
                        break;
                    case "Medium":
                        imageCell.Value = Properties.Resources.Medium;
                        break;
                    case "Minor":
                        imageCell.Value = Properties.Resources.Minor;
                        break;
                    default:
                        imageCell.Value = Properties.Resources.Minor;
                        break;
                }

                       
                    
            
            }
        }
        #endregion

        private void dataGridViewTasks_DoubleClick(object sender, EventArgs e)
        {
            return;
        }

        private void dataGridViewTasks_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            return;
        }

        private void dataGridViewTasks_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Task task = (Task)_taskBindingSource.Current;
            

            _presenter.TaskSelected(task);
        }
    }
}

