﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using TaskViewer.AuthService.BusinessEntities;

namespace TaskViewer.AuthService.DataAccess
{
    /// <summary>
    /// Construct a User object from a datareader.
    /// </summary>
    internal class GetUserInfoFactory : IDomainObjectFactory<User>
    {
        public User Construct(IDataReader reader)
        {
			User user = new User();
			
			int userIDIndex = reader.GetOrdinal("UserID"); 
            if(!reader.IsDBNull(userIDIndex))
            {
				user.UserID= reader.GetInt32(userIDIndex);

			}

			int userNameIndex = reader.GetOrdinal("UserName"); 
            if(!reader.IsDBNull(userNameIndex))
            {
				user.UserName= reader.GetString(userNameIndex);

			}

			int userFullNameIndex = reader.GetOrdinal("UserFullName"); 
            if(!reader.IsDBNull(userFullNameIndex))
            {
				user.UserFullName= reader.GetString(userFullNameIndex);

			}

			int userEmailIndex = reader.GetOrdinal("UserEmail"); 
            if(!reader.IsDBNull(userEmailIndex))
            {
				user.UserEmail= reader.GetString(userEmailIndex);

			}

			int isAdministratorIndex = reader.GetOrdinal("IsAdministrator"); 
            if(!reader.IsDBNull(isAdministratorIndex))
            {
				user.IsAdministrator= reader.GetBoolean(isAdministratorIndex);

			}

			int isAccountLockedIndex = reader.GetOrdinal("IsAccountLocked"); 
            if(!reader.IsDBNull(isAccountLockedIndex))
            {
				user.IsAccountLocked= reader.GetBoolean(isAccountLockedIndex);

			}

           
			return user; 
        }
    }
}

