using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Web.Security;
using System.Web;

using TaskViewer.AuthService.ServiceContracts;
using TaskViewer.AuthService.BusinessEntities;
using TaskViewer.AuthService.BusinessLogic;
using TaskViewer.AuthService.DataContracts;

namespace TaskViewer.AuthService.ServiceImplementation
{
    [ServiceBehavior(Name = "AuthorizationService", Namespace = "http://TaskViewer.AuthService.ServiceContracts/2007/07")]
    public class AuthorizationService : IAuthorizationService
    {
        static Dictionary<string, UserInformation> userHash = new Dictionary<string, UserInformation>();
        #region IAuthorizationService Members

        public GetAuthorizationTicketResponse GetAuthorizationTicket(GetAuthorizationTicketRequest request)
        {
            //TODO add caching from caching application block
           //get the ticket timeout in minutes
           Int32 timeout = Properties.Settings.Default.AuthenticationTicketTimeout;


           RegistrationManager manager = new RegistrationManager();
           User user = manager.AthenticateUser(request.userName, request.password);
           GetAuthorizationTicketResponse response = new GetAuthorizationTicketResponse();
           if(user!= null)
           {
               
               string ticket = DateTime.Now.ToString();
               userHash.Add(ticket, UserInformationUserTranslator.TranslateUserToUserInformation(user));
               response.GetAuthorizationTicketResult = ticket;
               
           }
           else
           {
               //TODO change it to get fault response
               response.GetAuthorizationTicketResult = "-1";
           }
           return response;
            //TODO change it
           //throw new NotImplementedException();


        }

        public GetUserInfoResponse GetUserInfo(GetUserInfoRequest request)
        {
            GetUserInfoResponse response = new GetUserInfoResponse();
            if (userHash.ContainsKey(request.ticket))
            {
                
                 
                 response.getUserInfoResult = userHash[request.ticket];
                 
            }
            else
            {
                response.getUserInfoResult = null;
            }
            return response;
                
        }

        public InsertUserResponse InsertUser(InsertUserRequest request)
        {
            User user = UserInformationUserTranslator.TranslateUserInformationToUser(request.userInfo);
            RegistrationManager manager = new RegistrationManager();
            InsertUserResponse response = new InsertUserResponse();
            response.insertUserResult = manager.InsertUser(user);
            return response;
        }

        public UpdateUserResponse UpdateUser(UpdateUserRequest request)
        {
            RegistrationManager manager = new RegistrationManager();
            User user = manager.UpdateUser
                (UserInformationUserTranslator.TranslateUserInformationToUser(request.userInfo));
                     
            UpdateUserResponse response = new UpdateUserResponse();

            response.updateUserResult = UserInformationUserTranslator.TranslateUserToUserInformation(user);
            return response;
        }

        public ChangePasswordResponse ChangePassword(ChangePasswordRequest request)
        {
            RegistrationManager manager = new RegistrationManager();
            User user = manager.UpdateUser(
                UserInformationUserTranslator.TranslateUserInformationToUser(request.userInfo));
            ChangePasswordResponse response =  new ChangePasswordResponse();
            response.changePasswordResult = UserInformationUserTranslator.TranslateUserToUserInformation(user);
            return response;
        }

        #endregion
    }
}
