using System;
using System.Collections.Generic;
using System.Text;

namespace TaskViewer.ProjectManagement.BusinessEntities
{
    public class SyncTask
    {
        public SyncTask()
        {
        }

        private Task _currentTask;
        private Task _originalTask;

        public SyncTask(Task currentTask, Task originalTask)
        {
            _currentTask = currentTask;
            _originalTask = originalTask;
        }

        public System.Int32 AssignedTo
        {
            get { return _currentTask.AssignedTo; }
        }

        public System.Int32 OriginalAssignedTo
        {
            get { return _originalTask.AssignedTo; }
        }

        public System.DateTime DateCreated
        {
            get { return _currentTask.DateCreated; }
        }

        public System.DateTime OriginalDateCreated
        {
            get { return _originalTask.DateCreated; }
        }

        

        public System.DateTime DateDue
        {
            get { return _currentTask.DateDue; }
        }


        public System.DateTime OriginalDateDue
        {
            get { return _originalTask.DateDue; }
        }

        public System.DateTime DateModified
        {
            get { return _currentTask.DateModified; }
        }

        public System.DateTime OriginalDateModified
        {
            get { return _originalTask.DateModified; }
        }

        public System.Boolean OriginalIsDeleted
        {
            get { return _originalTask.IsDeleted; }
        }

        public System.Boolean IsDeleted
        {
            get { return _currentTask.IsDeleted; }
        }

        public System.Int32 ModifiedBy
        {
            get { return _currentTask.ModifiedBy; }
        }

        public System.Int32 OriginalModifiedBy
        {
            get { return _originalTask.ModifiedBy; }
        }

        public System.Int32 PriorityID
        {
            get { return _currentTask.PriorityID; }
        }

        public System.Int32 OriginalPriorityID
        {
            get { return _originalTask.PriorityID; }
        }

        
        public System.Int32 Progress
        {
            get { return _currentTask.Progress; }
        }

        public System.Int32 OriginalProgress
        {
            get { return _originalTask.Progress; }
        }

        
        public System.Int32 ProjectID
        {
            get { return _currentTask.ProjectID; }
        }


        public System.Int32 OriginalProjectID
        {
            get { return _originalTask.ProjectID; }
        }

        
        public System.Int32 StatusID
        {
            get { return _currentTask.StatusID; }
        }

        public System.Int32 OriginalStatusID
        {
            get { return _originalTask.StatusID; }
        }

        
        public System.String TaskDescription
        {
            get { return _currentTask.TaskDescription; }
        }

        public System.String OriginalTaskDescription
        {
            get { return _originalTask.TaskDescription; }
        }

        public System.Int32 TaskID
        {
            get { return _currentTask.TaskID; }
        }

        public System.Int32 OriginalTaskID
        {
            get { return _originalTask.TaskID; }
        }

        public System.String TaskSummary
        {
            get { return _currentTask.TaskSummary; }
        }

        public System.String OrignalTaskSummary
        {
            get { return _originalTask.TaskSummary; }
        }

        private State _entityStatus;

        public State EntityStatus
        {
            get { return _entityStatus; }
            set { _entityStatus = value; }
        }

    }
}
