﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using TaskViewer.ProjectManagement.BusinessEntities;

namespace TaskViewer.DataService.DataAccess
{
    /// <summary>
    /// Construct a Task object from a datareader.
    /// </summary>
    internal class GetOneTaskFactory : IDomainObjectFactory<Task>
    {
        public Task Construct(IDataReader reader)
        {
            Task task = new Task();

            int taskSummaryIndex = reader.GetOrdinal("TaskSummary");
            if (!reader.IsDBNull(taskSummaryIndex))
            {
                task.TaskSummary = reader.GetString(taskSummaryIndex);

            }

            int taskIDIndex = reader.GetOrdinal("TaskID");
            if (!reader.IsDBNull(taskIDIndex))
            {
                task.TaskID = reader.GetInt32(taskIDIndex);

            }

            int taskDescriptionIndex = reader.GetOrdinal("TaskDescription");
            if (!reader.IsDBNull(taskDescriptionIndex))
            {
                task.TaskDescription = reader.GetString(taskDescriptionIndex);

            }

            int statusIDIndex = reader.GetOrdinal("StatusID");
            if (!reader.IsDBNull(statusIDIndex))
            {
                task.StatusID = reader.GetInt32(statusIDIndex);

            }

            int modifiedByIndex = reader.GetOrdinal("ModifiedBy");
            if (!reader.IsDBNull(modifiedByIndex))
            {
                task.ModifiedBy = reader.GetInt32(modifiedByIndex);

            }

            int assignedToIndex = reader.GetOrdinal("AssignedTo");
            if (!reader.IsDBNull(assignedToIndex))
            {
                task.AssignedTo = reader.GetInt32(assignedToIndex);

            }

            int assignedToTextIndex = reader.GetOrdinal("AssignedToText");
            if (!reader.IsDBNull(assignedToTextIndex))
            {
                task.AssignedToText = reader.GetString(assignedToTextIndex);

            }

            int modifiedByTextIndex = reader.GetOrdinal("ModifiedByText");
            if (!reader.IsDBNull(modifiedByTextIndex))
            {
                task.ModifiedByText = reader.GetString(modifiedByTextIndex);

            }

            int statusIDTextIndex = reader.GetOrdinal("StatusText");
            if (!reader.IsDBNull(statusIDTextIndex))
            {
                task.StatusIDText = reader.GetString(statusIDTextIndex);

            }

            int dateCreatedIndex = reader.GetOrdinal("DateCreated");
            if (!reader.IsDBNull(dateCreatedIndex))
            {
                task.DateCreated = reader.GetDateTime(dateCreatedIndex);

            }

            int dateDueIndex = reader.GetOrdinal("DateDue");
            if (!reader.IsDBNull(dateDueIndex))
            {
                task.DateDue = reader.GetDateTime(dateDueIndex);

            }

            int dateModifiedIndex = reader.GetOrdinal("DateModified");
            if (!reader.IsDBNull(dateModifiedIndex))
            {
                task.DateModified = reader.GetDateTime(dateModifiedIndex);

            }

            int isDeletedIndex = reader.GetOrdinal("IsDeleted");
            if (!reader.IsDBNull(isDeletedIndex))
            {
                task.IsDeleted = reader.GetBoolean(isDeletedIndex);

            }

            int progressIndex = reader.GetOrdinal("Progress");
            if (!reader.IsDBNull(progressIndex))
            {
                task.Progress = reader.GetInt32(progressIndex);

            }

            int projectIDIndex = reader.GetOrdinal("PriorityID");
            if (!reader.IsDBNull(projectIDIndex))
            {
                task.ProjectID = reader.GetInt32(projectIDIndex);

            }

            int priorityTextIndex = reader.GetOrdinal("PriorityText");
            if (!reader.IsDBNull(priorityTextIndex))
            {
                task.PriorityText = reader.GetString(priorityTextIndex);

            }

            int priorityIDIndex = reader.GetOrdinal("ProjectID");
            if (!reader.IsDBNull(priorityIDIndex))
            {
                task.PriorityID = reader.GetInt32(priorityIDIndex);

            }


            return task;
        }
    }
}

