﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using TaskViewer.ProjectManagement.BusinessEntities;

namespace TaskViewer.DataService.DataAccess
{
    /// <summary>
    /// Construct a Priority object from a datareader.
    /// </summary>
    internal class GetPrioritiesFactory : IDomainObjectFactory<Priority>
    {
        public Priority Construct(IDataReader reader)
        {
            Priority priority = new Priority();

            int priorityIDIndex = reader.GetOrdinal("PriorityID");
            if (!reader.IsDBNull(priorityIDIndex))
            {
                priority.PriorityID = reader.GetInt32(priorityIDIndex);

            }

            int priorityTextIndex = reader.GetOrdinal("PriorityText");
            if (!reader.IsDBNull(priorityTextIndex))
            {
                priority.PriorityText = reader.GetString(priorityTextIndex);

            }


            return priority;
        }
    }
}

