﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using TaskViewer.ProjectManagement.BusinessEntities;

namespace TaskViewer.DataService.DataAccess
{
    /// <summary>
    /// Construct a Project object from a datareader.
    /// </summary>
    internal class GetProjectsFactory : IDomainObjectFactory<Project>
    {
        public Project Construct(IDataReader reader)
        {
            Project project = new Project();

            int projectIDIndex = reader.GetOrdinal("ProjectID");
            if (!reader.IsDBNull(projectIDIndex))
            {
                project.ProjectID = reader.GetInt32(projectIDIndex);

            }

            int projectNameIndex = reader.GetOrdinal("ProjectName");
            if (!reader.IsDBNull(projectNameIndex))
            {
                project.ProjectName = reader.GetString(projectNameIndex);

            }

            int projectDescriptionIndex = reader.GetOrdinal("ProjectDescription");
            if (!reader.IsDBNull(projectDescriptionIndex))
            {
                project.ProjectDescription = reader.GetString(projectDescriptionIndex);

            }

            int dateCreatedIndex = reader.GetOrdinal("DateCreated");
            if (!reader.IsDBNull(dateCreatedIndex))
            {
                project.DateCreated = reader.GetDateTime(dateCreatedIndex);

            }


            return project;
        }
    }
}

