﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using TaskViewer.ProjectManagement.BusinessEntities;

namespace TaskViewer.DataService.DataAccess
{
    /// <summary>
    /// Construct a Status object from a datareader.
    /// </summary>
    internal class GetStatusesFactory : IDomainObjectFactory<Status>
    {
        public Status Construct(IDataReader reader)
        {
            Status status = new Status();

            int statusIDIndex = reader.GetOrdinal("StatusID");
            if (!reader.IsDBNull(statusIDIndex))
            {
                status.StatusID = reader.GetInt32(statusIDIndex);

            }

            int statusTextIndex = reader.GetOrdinal("StatusText");
            if (!reader.IsDBNull(statusTextIndex))
            {
                status.StatusText = reader.GetString(statusTextIndex);

            }


            return status;
        }
    }
}

